How to create collapsible tabs in EJ2 JavaScript Tab

04 Sep 202610 minutes to read

You can implement collapse and expand functionality in the Tab control by adding and removing a custom CSS class in the click event handler for each tab. Here’s how to achieve this:

  1. Define a CSS class to hide the content: Create a collapse class that sets the display property to none. Add this class to the content element in the created event to initially hide it.

  2. Set up event handlers:

    • Bind the selected event for the Tab to collapse the initially selected tab item.
    • Bind a custom click handler for the Tab headers.
  3. Implement the collapse/expand functionality: In the event handler, add and remove the collapse class to hide and show the corresponding tab content.

Here’s an example of how to create collapsible tabs:

ej.base.enableRipple(true);

var actLine;
var trgIndex;

//Initialize Tab component
var tabObj = new ej.navigations.Tab({
    created: tabCreated,
    selected: tabSelected,
    items: [
        {
            header: { 'text': 'Twitter' },
            content: 'Twitter is an online social networking service that enables users to send and read short 140-character ' +
            'messages called "tweets". Registered users can read and post tweets, but those who are unregistered can only read ' +
            'them. Users access Twitter through the website interface, SMS or mobile device app Twitter Inc. is based in San ' +
            'Francisco and has more than 25 offices around the world. Twitter was created in March 2006 by Jack Dorsey, ' +
            'Evan Williams, Biz Stone, and Noah Glass and launched in July 2006. The service rapidly gained worldwide popularity, ' +
            'with more than 100 million users posting 340 million tweets a day in 2012.The service also handled 1.6 billion ' +
            'search queries per day.'
        },
        {
            header: { 'text': 'Facebook' },
            content: 'Facebook is an online social networking service headquartered in Menlo Park, California. Its website was ' +
            'launched on February 4, 2004, by Mark Zuckerberg with his Harvard College roommates and fellow students Eduardo ' +
            'Saverin, Andrew McCollum, Dustin Moskovitz and Chris Hughes.The founders had initially limited the website\'\s ' +
            'membership to Harvard students, but later expanded it to colleges in the Boston area, the Ivy League, and Stanford ' +
            'University. It gradually added support for students at various other universities and later to high-school students.'
        },
        {
            header: { 'text': 'WhatsApp' },
            content: 'WhatsApp Messenger is a proprietary cross-platform instant messaging client for smartphones that operates ' +
            'under a subscription business model. It uses the Internet to send text messages, images, video, user location and ' +
            'audio media messages to other users using standard cellular mobile numbers. As of February 2016, WhatsApp had a user ' +
            'base of up to one billion,[10] making it the most globally popular messaging application. WhatsApp Inc., based in ' +
            'Mountain View, California, was acquired by Facebook Inc. on February 19, 2014, for approximately US$19.3 billion.'
        }
    ]
});
//Render initialized Tab component
tabObj.appendTo('#element');

function tabCreated() {
    // After tab created first tab content and active line are hidden by adding custom class to make it collapse state
    actLine = document.querySelector('.e-indicator');
    document.getElementById('e-content-element_0').classList.add('collapse');
    actLine.classList.add('collapse');
}
function tabSelected(e) {
    // If next tab item selected custom class is removed from content and active line element
    var cnttrgs = document.querySelectorAll('#element.e-tab > .e-content > .e-item');
    for (var i = 0; i < cnttrgs.length; i++) {
        cnttrgs[i].classList.remove('collapse');
    }
    if (actLine !== undefined) {
        actLine.classList.remove('collapse');
    }
    this.trgIndex = e.selectedIndex;
    // Custom click event binding for each tab item to make collapse/expand
    e.selectedItem.onclick = function (e) {
        updateCollapseClass(this.trgIndex);
    };
}
function updateCollapseClass(index) {
    // Custom classes are added/removed from tab content and active line element, when the same tab item again clicked
    var cntEle = document.getElementById('e-content-' + 'element_' + index);
    if (cntEle.classList.contains('collapse')) {
        cntEle.classList.remove('collapse');
        actLine.classList.remove('collapse');
    }
    else {
        cntEle.classList.add('collapse');
        actLine.classList.add('collapse');
    }
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Tab</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Tab">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/bootstrap5.3.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
    <style>
        .e-content .e-item {
            font-size: 12px;
            margin: 10px;
            text-align: justify;
        }

        .container {
            min-width: 350px;
            margin: 0 10px;
        }

        .info {
            margin: 10px;
            font-weight: bold;
        }

        .e-tab .e-content>.e-item.e-active.collapse {
            /* csslint allow: adjoining-classes */
            display: none;
        }

        .e-tab .e-tab-header .e-indicator.collapse {
            /* csslint allow: adjoining-classes */
            display: none;
        }
    </style>
</head>

<body>
    
    <div id="container">
        <div class="info">
            Collapsible Tabs
        </div>
        <span style="margin: 10px;">
            <i>The active tab can be toggled to expand and collapse its content.</i>
        </span>
        <br><br>
        <div id="element" class="e-background"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

How to create collapsible tabs in Vue Tabs

02 Sep 202614 minutes to read

Achieve collapse and expand functionality in the Tab by adding or removing a custom CSS class in a click event handler for each tab.

  • Define a CSS class that sets display: none. Here the collapse class is added to the content element to hide it.
  • Bind the select event of the Tab to collapse the initially selected Tab item, and bind a custom click handler for the Tab headers.
  • In the event handler, add or remove the collapse class to hide or show the corresponding Tab content.
<template>
	<div id="app">
		<div class="info">
			Collapsible Tabs
		</div>
		<span style="margin: 10px;">
			<i>The active tab can be toggled to expand and collapse its content.</i>
		</span>
		<br /><br />
		<ejs-tab id='collapsible_tab' class='e-background' ref='TabInstance' :created="tabCreated" :selected="tabSelected">
			<e-tabitems>
				<e-tabitem :header='headerText0' :content="content0"></e-tabitem>
				<e-tabitem :header='headerText1' :content="content1"></e-tabitem>
				<e-tabitem :header='headerText2' :content="content2"></e-tabitem>
			</e-tabitems>
		</ejs-tab>
	</div>
</template>
<script setup>

import { TabComponent as EjsTab, TabItemsDirective as ETabitems, TabItemDirective as ETabitem } from '@syncfusion/ej2-vue-navigations';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

const headerText0 = { 'text': 'Twitter' };
const headerText1 = { 'text': 'Facebook' };
const headerText2 = { 'text': 'WhatsApp' };

const content0 = 'Twitter is an online social networking service that enables users to send and read short'
	+ '140-character messages called "tweets". Registered users can read and post tweets, but those'
	+ 'who are unregistered can only read them. Users access Twitter through the website interface,'
	+ 'SMS or mobile device app Twitter Inc. is based in San Francisco and has more than 25 offices'
	+ 'around the world. Twitter was created in March 2006 by Jack Dorsey, Evan Williams, Biz Stone,'
	+ 'and Noah Glass and launched in July 2006. The service rapidly gained worldwide popularity,'
	+ 'with more than 100 million users posting 340 million tweets a day in 2012.The service also'
	+ 'handled 1.6 billion search queries per day.';
const content1 = 'Facebook is an online social networking service headquartered in Menlo Park, California.'
	+ 'Its website was launched on February 4, 2004, by Mark Zuckerberg with his Harvard College'
	+ 'roommates and fellow students Eduardo Saverin, Andrew McCollum, Dustin Moskovitz and Chris'
	+ 'Hughes.The founders had initially limited the website\'s membership to Harvard students, but'
	+ 'later expanded it to colleges in the Boston area, the Ivy League, and Stanford University. It'
	+ 'gradually added support for students at various other universities and later to high-school'
	+ 'students.';
const content2 = 'WhatsApp Messenger is a proprietary cross-platform instant messaging client for'
	+ 'smartphones that operates under a subscription business model. It uses the Internet to send'
	+ 'text messages, images, video, user location and audio media messages to other users using'
	+ 'standard cellular mobile numbers. As of February 2016, WhatsApp had a user base of up to one'
	+ 'billion,[10] making it the most globally popular messaging application. WhatsApp Inc., based in'
	+ 'Mountain View, California, was acquired by Facebook Inc. on February 19, 2014, for '
	+ 'approximately US$19.3 billion.';

let trgIndex;
let actLine;

const tabCreated = () => {
	// After tab created first tab content and active line are hidden by adding custom class to make it collapse state
	actLine = document.querySelector('.e-indicator');
	document.getElementById("e-content-collapsible_tab_0").classList.add('collapse');
	actLine.classList.add('collapse');
};
const tabSelected = (e) => {
	// If next tab item selected custom class is removed from content and active line element
	let cnttrgs = document.querySelectorAll('#collapsible_tab.e-tab > .e-content > .e-item');
	for (var i = 0; i < cnttrgs.length; i++) {
		cnttrgs[i].classList.remove('collapse');
	}
	if (actLine !== undefined) { actLine.classList.remove('collapse'); }
	trgIndex = e.selectedIndex;
	// Custom click event binding for each tab item to make collapse/expand
	e.selectedItem.addEventListener('click', function () {
		updateCollapseClass(trgIndex);
	}.bind());
};
const updateCollapseClass = (index) => {
	// Custom classes are added/removed from tab content and active line element, when the same tab item again clicked
	let cntEle = document.getElementById("e-content-collapsible_tab_" + index);
	if (cntEle.classList.contains('collapse')) {
		cntEle.classList.remove('collapse');
		actLine.classList.remove('collapse');
	} else {
		cntEle.classList.add('collapse');
		actLine.classList.add('collapse');
	}
};

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

#container {
	visibility: hidden;
}

#loader {
	color: #008cff;
	height: 40px;
	left: 45%;
	position: absolute;
	top: 45%;
	width: 30%;
}

.e-content .e-item {
	font-size: 12px;
	margin: 10px;
	text-align: justify;
}

.container {
	min-width: 350px;
	margin: 0 10px;
}

.info {
	margin: 10px;
	font-weight: bold;
}

.e-tab .e-content>.e-item.e-active.collapse {
	display: none;
}

.e-tab .e-tab-header .e-indicator.collapse {
	display: none;
}
</style>
<template>
  <div id="app">
    <div class="info">
      Collapsible Tabs
    </div>
    <span style="margin: 10px;">
      <i>The active tab can be toggled to expand and collapse its content.</i>
    </span>
    <br /><br />
    <ejs-tab id='collapsible_tab' class='e-background' ref='TabInstance' :created="tabCreated" :selected="tabSelected">
      <e-tabitems>
        <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
        <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
        <e-tabitem :header='headerText2' :content="content2"></e-tabitem>
      </e-tabitems>
    </ejs-tab>
  </div>
</template>
<script>

import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-vue-navigations';
import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);

export default {
  name: "App",
  components: {
    "ejs-tab": TabComponent,
    "e-tabitems": TabItemsDirective,
    "e-tabitem": TabItemDirective
  },
  data: function () {
    return {
      headerText0: { 'text': 'Twitter' },
      headerText1: { 'text': 'Facebook' },
      headerText2: { 'text': 'WhatsApp' },

      content0: 'Twitter is an online social networking service that enables users to send and read short'
        + '140-character messages called "tweets". Registered users can read and post tweets, but those'
        + 'who are unregistered can only read them. Users access Twitter through the website interface,'
        + 'SMS or mobile device app Twitter Inc. is based in San Francisco and has more than 25 offices'
        + 'around the world. Twitter was created in March 2006 by Jack Dorsey, Evan Williams, Biz Stone,'
        + 'and Noah Glass and launched in July 2006. The service rapidly gained worldwide popularity,'
        + 'with more than 100 million users posting 340 million tweets a day in 2012.The service also'
        + 'handled 1.6 billion search queries per day.',
      content1: 'Facebook is an online social networking service headquartered in Menlo Park, California.'
        + 'Its website was launched on February 4, 2004, by Mark Zuckerberg with his Harvard College'
        + 'roommates and fellow students Eduardo Saverin, Andrew McCollum, Dustin Moskovitz and Chris'
        + 'Hughes.The founders had initially limited the website\'s membership to Harvard students, but'
        + 'later expanded it to colleges in the Boston area, the Ivy League, and Stanford University. It'
        + 'gradually added support for students at various other universities and later to high-school'
        + 'students.',
      content2: 'WhatsApp Messenger is a proprietary cross-platform instant messaging client for'
        + 'smartphones that operates under a subscription business model. It uses the Internet to send'
        + 'text messages, images, video, user location and audio media messages to other users using'
        + 'standard cellular mobile numbers. As of February 2016, WhatsApp had a user base of up to one'
        + 'billion,[10] making it the most globally popular messaging application. WhatsApp Inc., based in'
        + 'Mountain View, California, was acquired by Facebook Inc. on February 19, 2014, for '
        + 'approximately US$19.3 billion.',
    }

  },

  mounted: function () {
    this.trgIndex;
    this.actLine;
  },

  methods: {
    tabCreated: function () {
      // After tab created first tab content and active line are hidden by adding custom class to make it collapse state
      this.actLine = document.querySelector('.e-indicator');
      document.getElementById("e-content-collapsible_tab_0").classList.add('collapse');
      this.actLine.classList.add('collapse');
    },
    tabSelected: function (e) {
      // If next tab item selected custom class is removed from content and active line element
      let cnttrgs = document.querySelectorAll('#collapsible_tab.e-tab > .e-content > .e-item');
      for (var i = 0; i < cnttrgs.length; i++) {
        cnttrgs[i].classList.remove('collapse');
      }
      if (this.actLine !== undefined) { this.actLine.classList.remove('collapse'); }
      this.trgIndex = e.selectedIndex;
      // Custom click event binding for each tab item to make collapse/expand
      e.selectedItem.addEventListener('click', function () {
        this.updateCollapseClass(this.trgIndex);
      }.bind(this));
    },
    updateCollapseClass: function (index) {
      // Custom classes are added/removed from tab content and active line element, when the same tab item again clicked
      let cntEle = document.getElementById("e-content-collapsible_tab_" + index);
      if (cntEle.classList.contains('collapse')) {
        cntEle.classList.remove('collapse');
        this.actLine.classList.remove('collapse');
      } else {
        cntEle.classList.add('collapse');
        this.actLine.classList.add('collapse');
      }
    },
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.e-content .e-item {
  font-size: 12px;
  margin: 10px;
  text-align: justify;
}

.container {
  min-width: 350px;
  margin: 0 10px;
}

.info {
  margin: 10px;
  font-weight: bold;
}

.e-tab .e-content>.e-item.e-active.collapse {
  display: none;
}

.e-tab .e-tab-header .e-indicator.collapse {
  display: none;
}
</style>

How to create collapsible Tabs in React Tab

You can achieve collapse and expand functionality in React Tab by adding and removing a custom CSS class in the click event handler for each tab.

Use the creating event to capture a reference to each React Tab item’s content element, then read or toggle the collapse class from the click handler.

  • Define a CSS class that sets the display style property to none. In this example, a collapse class is added to the content element to hide it using the created event.
  • Bind the selected event for React Tab to collapse the initially selected React Tab item, and bind a custom click handler for the React Tab headers.
  • In the event handler, add and remove the collapse class to hide and show the corresponding React Tab content.
import { useEffect, useRef, useState } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, SelectEventArgs } from '@syncfusion/ej2-react-navigations';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

const App = () => {
  const tabInstance = useRef(null);
  const [trgIndex, setrgIndex] = useState(0);
  let actLine;
  useEffect(() => {
    updateCollapseClass = updateCollapseClass;
  }, []);
  let updateCollapseClass = (index) => {
    // Custom classes are added/removed from tab content and active line element, when the same tab item again clicked
    const cntEle = tabInstance.current.element.querySelector("#e-content-element_" + index);
    actLine = tabInstance.current.element.querySelector('.e-indicator');
    if (cntEle.classList.contains('collapse')) {
      cntEle.classList.remove('collapse');
      actLine.classList.remove('collapse');
    } else {
      cntEle.classList.add('collapse');
      actLine.classList.add('collapse');
    }
  }

  const tabCreated = () => {
    // After tab created first tab content and active line are hidden by adding custom class
    actLine = tabInstance.current.element.querySelector('.e-indicator') as any;
    if (tabInstance.current.element.querySelector(".e-content-element_0") != null)
      (tabInstance.current.element.querySelector(".e-content-element_0") as any).classList.add('collapse');
    actLine.classList.add('collapse');
  }

  const tabSelected = (e) => {
    // If next tab item selected custom class is removed from content and active line element
    let cnttrgs = tabInstance.current.element.querySelectorAll('#element.e-tab > .e-content > .e-item');
    for (let i = 0; i < cnttrgs.length; i++) {
      cnttrgs[i].classList.remove('collapse');
    }
    if (actLine !== undefined) { actLine.classList.remove('collapse'); }
    setrgIndex(e.selectedIndex);
    e.selectedItem.onclick = (e) => {
      updateCollapseClass(trgIndex);
    };
  }

  const twitterContent = () => {
    return (<div>
      Twitter is an online social networking service that enables users to send and read short 140-character
      messages called "tweets". Registered users can read and post tweets, but those who are unregistered can only read
      them. Users access Twitter through the website interface, SMS or mobile device app Twitter Inc. is based in San
      Francisco and has more than 25 offices around the world. Twitter was created in March 2006 by Jack Dorsey,
      Evan Williams, Biz Stone, and Noah Glass and launched in July 2006. The service rapidly gained worldwide popularity,
      with more than 100 million users posting 340 million tweets a day in 2012.The service also handled 1.6 billion '
      search queries per day.
    </div>)
  }

  const faceBookContent = () => {
    return (<div>
      Facebook is an online social networking service headquartered in Menlo Park, California. Its website was
      launched on February 4, 2004, by Mark Zuckerberg with his Harvard College roommates and fellow students Eduardo
      Saverin, Andrew McCollum, Dustin Moskovitz and Chris Hughes.The founders had initially limited the website
      membership to Harvard students, but later expanded it to colleges in the Boston area, the Ivy League, and Stanford
      University. It gradually added support for students at various other universities and later to high-school students.
    </div>);
  }

  const WhatsAppContent = () => {
    return (
      <div>
        WhatsApp Messenger is a proprietary cross-platform instant messaging client for smartphones that operates
        under a subscription business model. It uses the Internet to send text messages, images, video, user location and
        audio media messages to other users using standard cellular mobile numbers. As of February 2016, WhatsApp had a user
        base of up to one billion,[10] making it the most globally popular messaging application. WhatsApp Inc., based in
        Mountain View, California, was acquired by Facebook Inc. on February 19, 2014, for approximately US$19.3 billion.
      </div>);
  }

  let headertext;
  headertext = [{ text: "Twitter" }, { text: "Facebook" }, { text: "WhatsApp" }];

  return (
    <TabComponent heightAdjustMode='Auto' className="e-background" id='element' ref={tabInstance} created={tabCreated} selected={tabSelected}>
      <TabItemsDirective>
        <TabItemDirective header={headertext[0]}
          content={twitterContent} />
        <TabItemDirective header={headertext[1]}
          content={faceBookContent} />
        <TabItemDirective header={headertext[2]}
          content={WhatsAppContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
import { useEffect, useRef, useState } from 'react';
import * as React from "react";
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, SelectEventArgs } from '@syncfusion/ej2-react-navigations';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

const App = () => {
  const tabInstance = useRef<TabComponent>(null);
  const [trgIndex, setrgIndex] = useState<number>(0);
  let actLine: HTMLElement;
  useEffect(() => {
    updateCollapseClass = updateCollapseClass;
  }, []);
  let updateCollapseClass = (index: number): void => {
    // Custom classes are added/removed from tab content and active line element, when the same tab item again clicked
    const cntEle: any = tabInstance.current.element.querySelector("#e-content-element_" + index);
    actLine = tabInstance.current.element.querySelector('.e-indicator') as any
    if (cntEle.classList.contains('collapse')) {
      cntEle.classList.remove('collapse');
      actLine.classList.remove('collapse');
    } else {
      cntEle.classList.add('collapse');
      actLine.classList.add('collapse');
    }
  }

  const tabCreated = (): void => {
    // After tab created first tab content and active line are hidden by adding custom class
    actLine = tabInstance.current.element.querySelector('.e-indicator') as any;
    if (tabInstance.current.element.querySelector(".e-content-element_0") != null)
      (tabInstance.current.element.querySelector(".e-content-element_0") as any).classList.add('collapse');
    actLine.classList.add('collapse');
  }

  const tabSelected = (e: SelectEventArgs): void => {
    // If next tab item selected custom class is removed from content and active line element
    let cnttrgs: NodeListOf<Element> = tabInstance.current.element.querySelectorAll('#element.e-tab > .e-content > .e-item');
    for (let i: number = 0; i < cnttrgs.length; i++) {
      cnttrgs[i].classList.remove('collapse');
    }
    if (actLine !== undefined) { actLine.classList.remove('collapse'); }
    setrgIndex(e.selectedIndex);
    e.selectedItem.onclick = (e: Event) => {
      updateCollapseClass(trgIndex);
    };
  }

  const twitterContent = () => {
    return (<div>
      Twitter is an online social networking service that enables users to send and read short 140-character
      messages called "tweets". Registered users can read and post tweets, but those who are unregistered can only read
      them. Users access Twitter through the website interface, SMS or mobile device app Twitter Inc. is based in San
      Francisco and has more than 25 offices around the world. Twitter was created in March 2006 by Jack Dorsey,
      Evan Williams, Biz Stone, and Noah Glass and launched in July 2006. The service rapidly gained worldwide popularity,
      with more than 100 million users posting 340 million tweets a day in 2012.The service also handled 1.6 billion '
      search queries per day.
    </div>)
  }

  const faceBookContent = () => {
    return (<div>
      Facebook is an online social networking service headquartered in Menlo Park, California. Its website was
      launched on February 4, 2004, by Mark Zuckerberg with his Harvard College roommates and fellow students Eduardo
      Saverin, Andrew McCollum, Dustin Moskovitz and Chris Hughes.The founders had initially limited the website
      membership to Harvard students, but later expanded it to colleges in the Boston area, the Ivy League, and Stanford
      University. It gradually added support for students at various other universities and later to high-school students.
    </div>);
  }

  const WhatsAppContent = () => {
    return (
      <div>
        WhatsApp Messenger is a proprietary cross-platform instant messaging client for smartphones that operates
        under a subscription business model. It uses the Internet to send text messages, images, video, user location and
        audio media messages to other users using standard cellular mobile numbers. As of February 2016, WhatsApp had a user
        base of up to one billion,[10] making it the most globally popular messaging application. WhatsApp Inc., based in
        Mountain View, California, was acquired by Facebook Inc. on February 19, 2014, for approximately US$19.3 billion.
      </div>);
  }

  let headertext: any;
  headertext = [{ text: "Twitter" }, { text: "Facebook" }, { text: "WhatsApp" }];

  return (
    <TabComponent heightAdjustMode='Auto' className="e-background" id='element' ref={tabInstance} created={tabCreated} selected={tabSelected}>
      <TabItemsDirective>
        <TabItemDirective header={headertext[0]}
          content={twitterContent} />
        <TabItemDirective header={headertext[1]}
          content={faceBookContent} />
        <TabItemDirective header={headertext[2]}
          content={WhatsAppContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.e-content .e-item {
    font-size: 12px;
    margin: 10px;
    text-align: justify;
}

.container {
    margin: 0 10px;
    min-width: 350px;
}

.info {
    margin: 10px;
    font-weight: bold;
}

.e-tab .e-content > .e-item.e-active.collapse { /* csslint allow: adjoining-classes */
    display: none;
}

.e-tab .e-tab-header .e-indicator.collapse { /* csslint allow: adjoining-classes */
    display: none;
}

How to create collapsible Tabs in Angular Tab

26 Sep 202611 minutes to read

The Angular Tab component can be configured to provide collapsible functionality by adding and removing custom CSS classes through event handlers. The implementation allows the active tab content to expand and all other panels to collapse, producing an accordion-like behavior within the Angular Tab structure.

Steps

  1. Define a CSS class with display: none to hide the collapsed panel.
  2. Use the created event to mark all panels as collapsed initially.
  3. Bind the selected event to remove the collapse class from the active panel and toggle classes on others.
  4. Optionally handle custom click events on tab headers for explicit toggle behavior.
.collapse {
    display: none;
}

Single-open behavior: To make only one Angular Tab open at a time, toggle the collapse class on every inactive panel inside the selected handler.

The event handler logic adds the collapse class to hide content and removes it to display content, creating smooth expand and collapse transitions.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { TabModule } from '@syncfusion/ej2-angular-navigations'




import { Component, ViewChild } from '@angular/core';
import { SelectEventArgs, TabComponent } from '@syncfusion/ej2-angular-navigations';
import { enableRipple, isNullOrUndefined } from '@syncfusion/ej2-base';

enableRipple(true);

/**
 * Collapsible Tab
 */

@Component({
imports: [
         FormsModule, TabModule
    ],


standalone: true,
    selector: 'app-container',
    template: `<ejs-tab id="element" class="e-background" (created)="tabCreated()" (selected)="tabSelected($event)" #element>
           <e-tabitems>
                    <e-tabitem [header]='headerText[0]'>
                        <ng-template #content>
                            Twitter is an online social networking service that enables users to send and read short 140-character messages called "tweets".
                            Registered users can read and post tweets, but those who are unregistered can only read them. Users access Twitter
                            through the website interface, SMS or mobile device app Twitter Inc. is based in San Francisco and has more than 25
                            offices around the world. Twitter was created in March 2006 by Jack Dorsey, Evan Williams, Biz Stone, and Noah Glass
                            and launched in July 2006. The service rapidly gained worldwide popularity, with more than 100 million users posting
                            340 million tweets a day in 2012.The service also handled 1.6 billion search queries per day.
                        </ng-template>
                    </e-tabitem>
                    <e-tabitem [header]='headerText[1]'>
                        <ng-template #content>
                            Facebook is an online social networking service headquartered in Menlo Park, California. Its website was launched on February
                            4, 2004, by Mark Zuckerberg with his Harvard College roommates and fellow students Eduardo Saverin, Andrew McCollum,
                            Dustin Moskovitz and Chris Hughes.The founders had initially limited the website\'\s membership to Harvard students,
                            but later expanded it to colleges in the Boston area, the Ivy League, and Stanford University. It gradually added support
                            for students at various other universities and later to high-school students.
                        </ng-template>
                    </e-tabitem>
                    <e-tabitem [header]='headerText[2]'>
                        <ng-template #content>
                            WhatsApp Messenger is a proprietary cross-platform instant messaging client for smartphones that operates under a subscription
                            business model. It uses the Internet to send text messages, images, video, user location and audio media messages to
                            other users using standard cellular mobile numbers. As of February 2016, WhatsApp had a user base of up to one billion,[10]
                            making it the most globally popular messaging application. WhatsApp Inc., based in Mountain View, California, was acquired
                            by Facebook Inc. on February 19, 2014, for approximately US$19.3 billion.
                        </ng-template>
                    </e-tabitem>
                </e-tabitems>
            </ejs-tab>`
})

export class AppComponent {

  @ViewChild('element') tabInstance!: TabComponent;

  public trgIndex?: number;
  public actLine?: HTMLElement;

  public headerText: Object[] = [
    { text: 'Twitter' },
    { text: 'Facebook' },
    { text: 'WhatsApp' }
  ];

  public tabCreated(): void {
    // Custom click event binding for each tab item to make collapse/expand
    const childrenArray = Array.from((this.tabInstance).element.children[0].children[0].children);
    const toolbarItem: Element[] = childrenArray.filter(el => el.classList.contains('e-toolbar-item'));
    (toolbarItem[0] as HTMLElement).onclick = (e: Event) => {
      this.updateCollapseClass(0);
    };

    (toolbarItem[1] as HTMLElement).onclick = (e: Event) => {
      this.updateCollapseClass(1);
    };

    (toolbarItem[2] as HTMLElement).onclick = (e: Event) => {
      this.updateCollapseClass(2);
    };

    // After tab created first tab content and active line are hidden by adding custom class to make it collapse state
    this.actLine = document.querySelector('.e-indicator') as HTMLElement;
    (this.tabInstance.element.children[1].children[0].classList.add('collapse'));
    this.actLine.classList.add('collapse');
  }

  public tabSelected(e: SelectEventArgs): void {
    // If next tab item selected custom class is removed from content and active line element
    const childrenArray = Array.from(this.tabInstance.element.children[1].children);
    const cnttrgs = childrenArray.filter(el => el.classList.contains('e-item'));
    for (let i: number = 0; i < cnttrgs.length; i++) {
      cnttrgs[i].classList.remove('collapse');
    }
    if (this.actLine !== undefined) {
      this.actLine.classList.remove('collapse');
    }
    this.trgIndex = e.selectedIndex;
  }

  public updateCollapseClass(index: number): void {
    // Custom classes are added/removed from tab content and active line element, when the same tab item again clicked
    const childrenArray = Array.from(this.tabInstance.element.children[1].children);
    const cntEle: HTMLElement = childrenArray.filter(el => el.id === `e-content-element_${index}`)[0] as HTMLElement;
    if (!isNullOrUndefined(cntEle) && cntEle.classList.contains('collapse')) {
      cntEle.classList.remove('collapse');
      (this.actLine as HTMLElement).classList.remove('collapse');
    } else if (!isNullOrUndefined(cntEle)) {
      cntEle.classList.add('collapse');
      (this.actLine as HTMLElement).classList.add('collapse');
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See Also